#!/bin/sh

# We need /proc:
/bin/busybox-init mount -av

# libs.tar.lzma exists only with floppies, not on CD-ROM:
[ -f /libs.tar.lzma ] && /bin/lzma d -si -so < /libs.tar.lzma 2> /dev/null | /bin/tar xf -

# The whole backbuffer can be seen with Shift+PgUp even we use dialog:
echo -e '\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'
DIALOGOPTS="--backtitle \"Tukaani Installer\""
export DIALOGOPTS

while [ ! -f /usr/lib/setup/setup ] ; do
dialog --title "INSERT DISK #2" --msgbox "Insert the Tukaani installation floppy disk #2
and press the ENTER key to continue." 6 53
dialog --title "PLEASE WAIT" --infobox "Loading the floppy into the RAM disk..." 3 43
/bin/lzma d -si -so < /dev/fd0 2> /dev/null | /bin/tar xf - > /dev/null 2> /dev/null
done

rm -f /libs.tar.lzma
/bin/setterm -blank 0

/sbin/syslogd 2> /dev/null
sleep 1
/sbin/klogd -c 3 1> /dev/null

while [ ! -f /etc/rc.d/rc.pcmcia ]; do
  dialog --title "LOAD OPTIONAL THIRD FLOPPY?" \
    --yes-label Load --no-label Skip --yesno \
"You have now successfully loaded the Tukaani installation
program. The first two floppies provide:
- Filesystems: ReiserFS, ISO9660, NFS, VFAT (FAT16/32)
- Network cards: PCI/ISA/MCA 10/100, also some 10/100/1000
- Serial ATA (SATA), USB storage
- 'plink' SSH/telnet client from PuTTY
The optional third floppy adds support for:
- Filesystems: ext2, ext3, JFS, NTFS, UDF
- The rest of the network cards
- PCMCIA, MD/RAID, SCSI, MMC, IEEE1394 (Firewire)

If you want to load the third floppy, insert it now and
press <Load>. Otherwise press <Skip>." 0 0
[ $? != 0 ] && break
dialog --title "PLEASE WAIT" --infobox "Loading the floppy into the RAM disk..." 3 43
/bin/lzma d -si -so < /dev/fd0 2> /dev/null | /bin/tar xf -
done

dialog --title "WELCOME TO TUKAANI INSTALLER" --yes-label Reduced \
--no-label All --yesno \
"Congratulations, you have successfully booted Tukaani Installer! \n\
\n\
Select the amount of questions you are willing to see:\n\
* REDUCED: In reduced mode only the most important question \n\
  are shown such as partitioning, filesystem and the selection \n\
  of packages to be installed. The reduced questions mode is \n\
  usually a good choice especially for newbies. \n\
* ALL: If you have a PCMCIA or an old ISA network or SCSI card, \n\
  other more special hardware, or if you have had any problems \n\
  in recuded mode, you should choose to show all questions. \n\
\n\
Use arrow keys to move the selection and press enter to accept \n\
the choice." \
17 70 \
&& rm -f /etc/expert-mode

USE_HOTPLUG=1
if [ -f /etc/expert-mode ]; then
dialog --title "START HOTPLUG AND UDEV?" --yesno \
"Do you want to use hotplug\nto autodetect the hardware?" 0 0 \
|| USE_HOTPLUG=0
fi

if [ $USE_HOTPLUG = 1 ]; then
. /etc/udev/udev.conf
ACTION=add UDEV_NO_SLEEP=1 /sbin/udevstart
. /etc/udev/scripts/make_extra_nodes.sh
else
# sysctl support is probably disabled.
mv /sbin/hotplug /sbin/hotplug.disabled
fi

if [ -f /etc/expert-mode -a -f /etc/rc.d/rc.pcmcia ]; then
  dialog --title "ACTIVATE PCMCIA?" --defaultno --yesno \
"If you need a PCMCIA network card or disk drive,
you should activate PCMCIA now.

Do you want to activate PCMCIA?" 0 0
if [ $? = 0 ]; then
clear
echo
/etc/rc.d/rc.pcmcia start
echo
echo "Press enter to continue."
read foo
fi
fi

if [ $USE_HOTPLUG = 1 ]; then
  dialog --title "DETECTING HARDWARE" --infobox "Running hotplug, please wait..." 3 36
  . /etc/rc.d/rc.hotplug start 2>&1 | logger
else
  /bin/sh /dev/makedevs.sh
fi

[ -d /proc/bus/usb -a ! -f /proc/bus/usb/devices ] && mount -t usbfs usbfs /proc/bus/usb
[ -x /etc/rc.d/rc.inet1 ] && /bin/sh /etc/rc.d/rc.inet1
